#include "benchmark.h"
#include "rand.h"

double fpow(double a, int k){
	double product = 1;
	for(int i = 0; i < k; i++)
		product *= a;
	return product;
}


double doubledip(double x, double c, double s){
	if(x > -0.5 && x < 0.5)
		return ( (-6144*fpow((x - c), 6) + 3088*fpow((x - c), 4) - 392*(x - c)*(x - c) + 1)*s);
	else
		return 0;
}

double fractal1D(double x){
	double sum = 0;
	for(int k = 1; k <= 3; k++)
		for(int i = 1; i <= fpow(2.0,k-1); i++)
			for(int j = 1; j <= rnd(0,2); j++)
				sum += doubledip(x, randomperc(), 1.0/(fpow(2.0, k - 1)*(2.0 - randomperc())));
	return sum;
}

double twist(double y){
	return 4*(fpow(y,4) - 2*fpow(y,3) + y*y);
}

double f7(int dim, double x[]){
	double sum = 0;
	for(int i = 0; i < dim; i++)
		sum += fractal1D(x[i] + twist(x[(i + 1) % dim]));
	return sum;
}